Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/domain.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/domain.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/domain.f90	(revision 5600)
@@ -342,8 +565,4 @@
       INTEGER(i4), INTENT(IN), OPTIONAL :: id_jmin
       INTEGER(i4), INTENT(IN), OPTIONAL :: id_jmax
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_kmin
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_kmax
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_lmin
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_lmax
       !----------------------------------------------------------------
 
@@ -354,64 +573,62 @@
       IF( PRESENT(id_jmax) ) td_dom%i_jmax = id_jmax
 
-!      IF( PRESENT(id_kmin) ) td_dom%i_kmin = id_kmin
-!      IF( PRESENT(id_kmax) ) td_dom%i_kmax = id_kmax
-!
-!      IF( PRESENT(id_lmin) ) td_dom%i_lmin = id_lmin
-!      IF( PRESENT(id_lmax) ) td_dom%i_lmax = id_lmax
-
       ! check indices
-      IF(( td_dom%i_imin < 0 .OR. td_dom%i_imin > td_dom%t_dim0(1)%i_len ).OR. &
-      &  ( td_dom%i_imax < 0 .OR. td_dom%i_imax > td_dom%t_dim0(1)%i_len ).OR. &
-      &  ( td_dom%i_jmin < 0 .OR. td_dom%i_jmin > td_dom%t_dim0(2)%i_len ).OR. &
-      &  ( td_dom%i_jmax < 0 .OR. td_dom%i_jmax > td_dom%t_dim0(2)%i_len ))THEN
-!      &  ( td_dom%i_kmin < 0 .OR. td_dom%i_kmin > td_dom%t_dim0(3)%i_len ).OR. &
-!      &  ( td_dom%i_kmax < 0 .OR. td_dom%i_kmax > td_dom%t_dim0(3)%i_len ).OR. &
-!      &  ( td_dom%i_lmin < 0 .OR. td_dom%i_lmin > td_dom%t_dim0(4)%i_len ).OR. &
-!      &  ( td_dom%i_lmax < 0 .OR. td_dom%i_lmax > td_dom%t_dim0(4)%i_len ))THEN
-         CALL logger_error( "DOM INIT DEFINE: invalid grid definition."// &
+      IF(( td_dom%i_imin < -1 .OR. td_dom%i_imin > td_dom%t_dim0(1)%i_len ).OR. &
+      &  ( td_dom%i_imax < -1 .OR. td_dom%i_imax > td_dom%t_dim0(1)%i_len ).OR. &
+      &  ( td_dom%i_jmin < -1 .OR. td_dom%i_jmin > td_dom%t_dim0(2)%i_len ).OR. &
+      &  ( td_dom%i_jmax < -1 .OR. td_dom%i_jmax > td_dom%t_dim0(2)%i_len ))THEN
+         CALL logger_debug("0 <= imin ("//TRIM(fct_str(id_imin))//") < "//&
+         &              TRIM(fct_str(td_dom%t_dim0(1)%i_len)))
+         CALL logger_debug("0 <= imax ("//TRIM(fct_str(id_imax))//") < "//&
+         &              TRIM(fct_str(td_dom%t_dim0(1)%i_len)))
+         CALL logger_debug("0 <= jmin ("//TRIM(fct_str(id_jmin))//") < "//&
+         &              TRIM(fct_str(td_dom%t_dim0(2)%i_len)))
+         CALL logger_debug("0 <= jmax ("//TRIM(fct_str(id_jmax))//") < "//&
+         &              TRIM(fct_str(td_dom%t_dim0(2)%i_len)))
+         CALL logger_fatal( "DOM INIT DEFINE: invalid grid definition."// &
          &               " check min and max indices")
-         CALL logger_debug("0 < imin ("//TRIM(fct_str(id_imin))//") < "//&
-         &              TRIM(fct_str(td_dom%t_dim0(1)%i_len)))
-         CALL logger_debug("0 < imax ("//TRIM(fct_str(id_imax))//") < "//&
-         &              TRIM(fct_str(td_dom%t_dim0(1)%i_len)))
-         CALL logger_debug("0 < jmin ("//TRIM(fct_str(id_jmin))//") < "//&
-         &              TRIM(fct_str(td_dom%t_dim0(2)%i_len)))
-         CALL logger_debug("0 < jmax ("//TRIM(fct_str(id_jmax))//") < "//&
-         &              TRIM(fct_str(td_dom%t_dim0(2)%i_len)))
-!         CALL logger_debug("0 < kmin ("//TRIM(fct_str(id_kmin))//") < "//&
-!         &              TRIM(fct_str(td_dom%t_dim0(3)%i_len)))
-!         CALL logger_debug("0 < kmax ("//TRIM(fct_str(id_kmax))//") < "//&
-!         &              TRIM(fct_str(td_dom%t_dim0(3)%i_len)))
-!         CALL logger_debug("0 < lmin ("//TRIM(fct_str(id_lmin))//") < "//&
-!         &              TRIM(fct_str(td_dom%t_dim0(4)%i_len)))
-!         CALL logger_debug("0 < lmax ("//TRIM(fct_str(id_lmax))//") < "//&
-!         &              TRIM(fct_str(td_dom%t_dim0(4)%i_len)))
       ELSE
 
-!         td_dom%t_dim(3)%i_len=td_dom%i_kmax-td_dom%i_kmin+1
-!         td_dom%t_dim(4)%i_len=td_dom%i_lmax-td_dom%i_lmin+1
+         ! force to select north fold
+         IF( td_dom%i_perio0 > 2 .AND. &
+         &   ( td_dom%i_jmax >= td_dom%t_dim0(2)%i_len-1 .OR. &
+         &     td_dom%i_jmax < td_dom%i_jmin .OR. &
+         &     td_dom%i_jmin == 0 ) )THEN
+            td_dom%i_jmax=0
+         ENDIF
+
+         ! force to use cyclic boundary
+         IF( ( td_dom%i_perio0 == 1 .OR. &
+         &     td_dom%i_perio0 == 4 .OR. &
+         &     td_dom%i_perio0 == 6 ) .AND. &
+         &   ( td_dom%i_imin == 0 .OR. td_dom%i_imax == 0 .OR. &
+         &     ABS(td_dom%i_imax-td_dom%i_imin)+1 == td_dom%t_dim0(1)%i_len ) &
+         &  )THEN
+            td_dom%i_imin = 0
+            td_dom%i_imax = 0
+         ENDIF
 
          SELECT CASE(td_dom%i_perio0)
             CASE(0) ! closed boundary
-               CALL logger_trace("DEFINE: closed boundary")
+               CALL logger_trace("DOM INIT DEFINE: closed boundary")
                CALL dom__define_closed( td_dom )
             CASE(1) ! cyclic east-west boundary
-               CALL logger_trace("DEFINE: cyclic east-west boundary")
+               CALL logger_trace("DOM INIT DEFINE: cyclic east-west boundary")
                CALL dom__define_cyclic( td_dom )
             CASE(2) ! symmetric boundary condition across the equator
-               CALL logger_trace("DEFINE: symmetric boundary condition "//&
+               CALL logger_trace("DOM INIT DEFINE: symmetric boundary condition "//&
                &                 " across the equator")
                CALL dom__define_symmetric( td_dom )
             CASE(3) ! North fold boundary (with a F-point pivot)  
-               CALL logger_trace("DEFINE: North fold boundary "//&
+               CALL logger_trace("DOM INIT DEFINE: North fold boundary "//&
                &                 "(with a F-point pivot)")
                CALL dom__define_north_fold( td_dom )
             CASE(5) ! North fold boundary (with a T-point pivot)
-               CALL logger_trace("DEFINE: North fold boundary "//&
+               CALL logger_trace("DOM INIT DEFINE: North fold boundary "//&
                &                 "(with a T-point pivot)")
                CALL dom__define_north_fold( td_dom )
             CASE(4) ! North fold boundary (with a F-point pivot) 
                     ! and cyclic east-west boundary
-               CALL logger_trace("DEFINE:  North fold boundary "//&
+               CALL logger_trace("DOM INIT DEFINE:  North fold boundary "//&
                &                 "(with a F-point pivot) and cyclic "//&
                &                 "east-west boundary")
@@ -419,10 +636,10 @@
             CASE(6) ! North fold boundary (with a T-point pivot) 
                     ! and cyclic east-west boundary
-               CALL logger_trace("DEFINE: North fold boundary "//&
+               CALL logger_trace("DOM INIT DEFINE: North fold boundary "//&
                &                 "(with a T-point pivot) and cyclic "//&
                &                 "east-west boundary")
                CALL dom__define_cyclic_north_fold( td_dom )
             CASE DEFAULT
-               CALL logger_error("DEFINE: invalid grid periodicity index")
+               CALL logger_error("DOM INIT DEFINE: invalid grid periodicity index")
          END SELECT
 
@@ -430,16 +647,16 @@
 
    END SUBROUTINE dom__define
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine define domain indices from global domain with
+   !> This subroutine define sub domain indices from global domain with
    !> cyclic east-west boundary and north fold boundary condition.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !> @date September, 2014
+   !> - use zero indice to defined cyclic or global domain
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__define_cyclic_north_fold( td_dom )
       IMPLICIT NONE
@@ -448,10 +665,10 @@
       !----------------------------------------------------------------
 
-      CALL dom__check_EW_index( td_dom )
-
-      IF( td_dom%i_imin == td_dom%i_imax .AND. &
-      &   td_dom%i_jmin == td_dom%i_jmax )THEN
-
-         CALL logger_trace("DEFINE CYCLIC NORTH FOLD: "//&
+      !CALL dom__check_EW_index( td_dom )
+
+      IF( td_dom%i_imin == 0 .AND. td_dom%i_imax == 0 .AND. &
+      &   td_dom%i_jmin == 0 .AND. td_dom%i_jmax == 0 )THEN
+
+         CALL logger_trace("DOM DEFINE CYCLIC NORTH FOLD: "//&
          &  "domain to extract is global" )
          ! coarse domain is global domain
@@ -459,52 +676,38 @@
          CALL dom__size_global( td_dom )
 
-      ELSEIF( td_dom%i_imin == td_dom%i_imax .AND. &
-      &       td_dom%i_jmin >= td_dom%i_jmax )THEN
-
-         CALL logger_trace("DEFINE CYCLIC NORTH FOLD: "//&
+      ELSEIF( td_dom%i_imin == 0 .AND. td_dom%i_imax == 0 .AND. &
+      &       td_dom%i_jmax == 0 )THEN
+
+         CALL logger_trace("DOM DEFINE CYCLIC NORTH FOLD: "//&
          &  "domain to extract is semi-global" )
 
          CALL dom__size_semi_global( td_dom )
 
-      ELSEIF( td_dom%i_imin == td_dom%i_imax .AND. &
-      &       td_dom%i_jmin < td_dom%i_jmax )THEN
-
-         CALL logger_trace("DEFINE CYCLIC NORTH FOLD: "//&
+      ELSEIF( td_dom%i_imin == 0 .AND. td_dom%i_imax == 0 .AND. &
+      &       td_dom%i_jmax /= 0 )THEN
+
+         CALL logger_trace("DOM DEFINE CYCLIC NORTH FOLD: "//&
          &  "domain to extract is band of latidue" )
 
          CALL dom__size_no_pole( td_dom )
 
-      ELSEIF( td_dom%i_imin /= td_dom%i_imax .AND. &
-      &       td_dom%i_jmin == td_dom%i_jmax )THEN
-
-         CALL logger_trace("DEFINE CYCLIC NORTH FOLD: "//&
-         &  "domain to extract has north boundary" )
+      ELSEIF( td_dom%i_jmax == 0 )THEN
+
+         CALL logger_trace("DOM DEFINE CYCLIC NORTH FOLD: "//&
+         &  "domain to extract use north fold" )
 
          CALL dom__size_pole( td_dom )
 
-      ELSEIF( td_dom%i_imin /= td_dom%i_imax .AND. &
-      &       td_dom%i_jmin /= td_dom%i_jmax )THEN
-
-         IF( td_dom%i_jmax < td_dom%t_dim0(2)%i_len-1 .AND. &
-         &   td_dom%i_jmax > td_dom%i_jmin )THEN
-
-            CALL logger_trace("DEFINE CYCLIC NORTH FOLD: "//&
-            &  "domain to extract has no north boundary" )
-            ! no North Pole
-            
-            CALL dom__size_no_pole( td_dom )
-
-         ELSE
-
-            CALL logger_trace("DEFINE CYCLIC NORTH FOLD: "//&
-            &  "domain to extract has north boundary" )
-
-            CALL dom__size_pole( td_dom )
-
-         ENDIF
+      ELSEIF( td_dom%i_jmax /= 0 )THEN
+
+         CALL logger_trace("DOM DEFINE CYCLIC NORTH FOLD: "//&
+         &  "domain to extract do not use north fold" )
+         ! no North Pole
+         
+         CALL dom__size_no_pole( td_dom )
 
       ELSE
 
-         CALL logger_error("DEFINE CYCLIC NORTH FOLD: "//&
+         CALL logger_error("DOM DEFINE CYCLIC NORTH FOLD: "//&
          &  "should have been an impossible case" )
 
@@ -512,16 +715,14 @@
       
    END SUBROUTINE dom__define_cyclic_north_fold
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine define extract domain indices from global domain 
+   !> This subroutine define sub domain indices from global domain 
    !> with north fold boundary condition.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__define_north_fold( td_dom )
       IMPLICIT NONE
@@ -530,8 +731,7 @@
       !----------------------------------------------------------------
 
-      IF( td_dom%i_jmax < td_dom%t_dim0(2)%i_len-1 .AND. &
-      &   td_dom%i_jmax > td_dom%i_jmin )THEN
-
-         CALL logger_trace("DEFINE NORTH FOLD: "//&
+      IF( td_dom%i_jmax /= 0 )THEN
+
+         CALL logger_trace("DOM DEFINE NORTH FOLD: "//&
          &  "domain to extract has no north boundary" )
          ! no North Pole
@@ -541,6 +741,6 @@
       ELSE
 
-         CALL logger_trace("DEFINE NORTH FOLD: "//&
-         &  "domain to extract has north boundary" )
+         CALL logger_trace("DOM DEFINE NORTH FOLD: "//&
+         &  "sub domain has north boundary" )
 
          CALL dom__size_pole_no_overlap( td_dom )
@@ -549,16 +749,14 @@
 
    END SUBROUTINE dom__define_north_fold
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine define extract domain indices from global domain 
+   !> This subroutine define sub domain indices from global domain 
    !> with symmetric boundary condition across the equator.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__define_symmetric( td_dom )
       IMPLICIT NONE
@@ -570,16 +768,14 @@
 
    END SUBROUTINE dom__define_symmetric
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine define extract domain indices from global domain
+   !> This subroutine define sub domain indices from global domain
    !> with cyclic east-west boundary.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__define_cyclic( td_dom )
       IMPLICIT NONE
@@ -587,8 +783,7 @@
       TYPE(TDOM), INTENT(INOUT) :: td_dom
       !----------------------------------------------------------------
-      CALL dom__check_EW_index( td_dom )
       
       IF( td_dom%i_imin >= td_dom%i_imax )THEN
-         CALL logger_trace("DEFINE CYCLIC: "//&
+         CALL logger_trace("DOM DEFINE CYCLIC: "//&
          &  "domain to extract overlap east-west boundary")
 
@@ -597,5 +792,5 @@
       ELSE
          ! id_imin < id_imax
-         CALL logger_trace("DEFINE CYCLIC: "//&
+         CALL logger_trace("DOM DEFINE CYCLIC: "//&
          &  "domain to extract do not overlap east-west boundary")
 
@@ -605,16 +800,14 @@
 
    END SUBROUTINE dom__define_cyclic
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine define extract domain indices from global domain
+   !> This subroutine define sub domain indices from global domain
    !> with closed boundaries.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__define_closed( td_dom )
       IMPLICIT NONE
@@ -626,35 +819,4 @@
 
    END SUBROUTINE dom__define_closed
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief 
-   !> This subroutine check East-West indices, use inside a cyclic domain,
-   !> and redefine it in some particular cases.
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE dom__check_EW_index( td_dom )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TDOM), INTENT(INOUT) :: td_dom
-      !----------------------------------------------------------------
-
-      IF( td_dom%i_imin /= td_dom%i_imax )THEN
-
-         IF((ABS(td_dom%i_imax-td_dom%i_imin) >= td_dom%t_dim0(1)%i_len-1).OR.&
-            (ABS(td_dom%i_imax-td_dom%i_imin) <= td_dom%i_ew0 ) )THEN
-
-            td_dom%i_imin = td_dom%i_imax
-
-         ENDIF
-
-      ENDIF
-
-   END SUBROUTINE dom__check_EW_index
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -662,9 +824,8 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__size_global( td_dom )
       IMPLICIT NONE
@@ -684,8 +845,7 @@
 
       ! no ghost cell to add
-      td_dom%i_ighost=0
-      td_dom%i_jghost=0
-
-      ! peiordicity
+      td_dom%i_ghost(:,:)=0
+
+      ! periodicity
       IF( td_dom%i_pivot == 0 )THEN ! 0-F
          td_dom%i_perio=4
@@ -697,5 +857,4 @@
 
    END SUBROUTINE dom__size_global
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -703,10 +862,9 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
    !> @note never tested
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE dom__size_semi_global( td_dom )
       IMPLICIT NONE
@@ -715,5 +873,5 @@
 
       ! local variable
-      INTEGER(i4) :: il_imid   ! cananadian bipole index (middle of global domain) 
+      INTEGER(i4) :: il_imid   ! canadian bipole index (middle of global domain) 
       !----------------------------------------------------------------
 
@@ -723,23 +881,18 @@
       td_dom%i_imax = il_imid !td_dom%t_dim0(1)%i_len
 
-      IF( td_dom%i_jmax >= td_dom%t_dim0(2)%i_len-1 )THEN
-         td_dom%i_jmax=MIN( td_dom%i_jmin, & 
-         &                  td_dom%t_dim0(2)%i_len-td_dom%i_jmax )
-      ELSE
-         td_dom%i_jmin=td_dom%i_jmax
-      ENDIF
+      IF( td_dom%i_jmin == 0 ) td_dom%i_jmin=1
+      td_dom%i_jmax = td_dom%t_dim0(2)%i_len
 
       ! domain size
-      td_dom%t_dim(1)%i_len = (td_dom%i_imax ) - &
-      &                         (td_dom%i_imin ) + 1
+      td_dom%t_dim(1)%i_len = td_dom%i_imax - &
+      &                       td_dom%i_imin + 1
 
       td_dom%t_dim(2)%i_len = ( td_dom%t_dim0(2)%i_len - &
-      &                         ( td_dom%i_jmin ) + 1 ) +      &
+      &                         td_dom%i_jmin + 1 ) +      &
       &                         ( td_dom%t_dim0(2)%i_len - &
-      &                         ( td_dom%i_jmax ) + 1 ) - 2    ! remove north fold condition ?
+      &                           td_dom%i_jmin + 1 ) - 2    ! remove north fold condition ?
 
       ! ghost cell to add
-      td_dom%i_ighost=1
-      td_dom%i_jghost=1
+      td_dom%i_ghost(:,:)=1
 
       ! periodicity
@@ -753,16 +906,14 @@
 
    END SUBROUTINE dom__size_semi_global
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine compute size of an extract domain without north fold
+   !> This subroutine compute size of sub domain without north fold
    !> condition
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__size_no_pole( td_dom )
       IMPLICIT NONE
@@ -771,12 +922,13 @@
       !----------------------------------------------------------------
 
-      IF( td_dom%i_jmin >= td_dom%i_jmax )THEN
-         CALL logger_fatal("DOM INIT: invalid domain. "//&
+      IF( td_dom%i_jmax == 0 )THEN
+         CALL logger_fatal("DOM SIZE NO POLE: invalid domain. "//&
          &  "can not get north pole from this coarse grid. "//&
          &  "check namelist and coarse grid periodicity." )
       ENDIF
 
-      IF( td_dom%i_imin >= td_dom%i_imax )THEN
-         CALL logger_trace("DEFINE NO POLE: "// &
+      IF( td_dom%i_imin == 0 .AND. td_dom%i_imax == 0 .OR. &
+      &   td_dom%i_imin > td_dom%i_imax )THEN
+         CALL logger_trace("DOM SIZE NO POLE: "// &
          &  "domain to extract overlap east-west boundary")
 
@@ -785,5 +937,5 @@
       ELSE
          ! id_imin < id_imax
-         CALL logger_trace("DEFINE NO POLE: "// &
+         CALL logger_trace("DOM SIZE NO POLE: "// &
          &  "domain to extract do not overlap east-west boundary")
 
@@ -793,16 +945,15 @@
 
    END SUBROUTINE dom__size_no_pole
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine compute size of an extract domain with north fold
-   !> condition
+   !> This subroutine compute size of sub domain with north fold
+   !> condition.
    !>
    !> @author J.Paul
    !> - April, 2013- Subroutine written
    !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] td_dom domain strcuture
+   !> @note never tested
+   !-------------------------------------------------------------------
    SUBROUTINE dom__size_pole( td_dom )
       IMPLICIT NONE
@@ -811,10 +962,10 @@
       !----------------------------------------------------------------
 
-      IF( td_dom%i_imin > td_dom%i_imax )THEN
-         CALL logger_trace("DEFINE POLE: "//&
+      IF( td_dom%i_imin >= td_dom%i_imax )THEN
+         CALL logger_trace("DOM SIZE POLE: "//&
          &  "domain to extract overlap east-west boundary")
          CALL dom__size_pole_overlap( td_dom )
       ELSEIF( td_dom%i_imin < td_dom%i_imax )THEN
-         CALL logger_trace("DEFINE POLE: "//&
+         CALL logger_trace("DOM SIZE POLE: "//&
          &  "domain to extract do not overlap east-west boundary")
          CALL dom__size_pole_no_overlap( td_dom )
@@ -822,16 +973,14 @@
 
    END SUBROUTINE dom__size_pole
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine compute size of an extract domain without north fold
+   !> This subroutine compute size of sub domain without north fold
    !> condition, and which overlap east-west boundary
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__size_no_pole_overlap( td_dom )
       IMPLICIT NONE
@@ -840,13 +989,13 @@
       !----------------------------------------------------------------
 
-      IF( td_dom%i_jmin >= td_dom%i_jmax )THEN
-         CALL logger_fatal("DOM INIT: invalid domain. "//&
+      IF( td_dom%i_jmax == 0 )THEN
+         CALL logger_fatal("DOM SIZE NO POLE OVERLAP: invalid domain. "//&
          &  "can not get north pole from this coarse grid. "//&
          &  "check namelist and coarse grid periodicity." )
       ENDIF
 
-      IF( td_dom%i_imin == td_dom%i_imax )THEN
+      IF( td_dom%i_imin == 0 .AND. td_dom%i_imax == 0 )THEN
          ! domain to extract with east west cyclic boundary
-         CALL logger_trace("DEFINE NO POLE OVERLAP: "//&
+         CALL logger_trace("DOM SIZE NO POLE OVERLAP: "//&
          &  "domain to extract has cyclic east-west boundary")
 
@@ -857,5 +1006,5 @@
 
          ! no ghost cell
-         td_dom%i_ighost=0
+         td_dom%i_ghost(jp_I,:)=0
 
          ! periodicity
@@ -867,10 +1016,10 @@
          ! extract domain overlap east-west boundary
 
-         td_dom%t_dim(1)%i_len = td_dom%t_dim0(1)%i_len -             &
-         &                       (td_dom%i_imin ) + 1 + & 
-         &                       (td_dom%i_imax ) - 2     ! remove cyclic boundary
+         td_dom%t_dim(1)%i_len = td_dom%i_imax + &
+         &                       td_dom%t_dim0(1)%i_len - td_dom%i_imin + 1 - & 
+         &                       td_dom%i_ew0     ! remove cyclic boundary
 
          ! add ghost cell
-         td_dom%i_ighost=1
+         td_dom%i_ghost(jp_I,:)=1
 
          ! periodicity
@@ -879,23 +1028,21 @@
       ENDIF
 
-      td_dom%t_dim(2)%i_len = (td_dom%i_jmax ) - &
-      &                       (td_dom%i_jmin ) + 1
+      td_dom%t_dim(2)%i_len = td_dom%i_jmax - &
+      &                       td_dom%i_jmin + 1
 
       ! add ghost cell
-      td_dom%i_jghost=1
+      td_dom%i_ghost(jp_J,:)=1
 
    END SUBROUTINE dom__size_no_pole_overlap
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine compute size of an extract domain without north fold
+   !> This subroutine compute size of sub domain without north fold
    !> condition, and which do not overlap east-west boundary
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom__size_no_pole_no_overlap( td_dom )
       IMPLICIT NONE
@@ -904,25 +1051,24 @@
       !----------------------------------------------------------------
 
-      IF( td_dom%i_jmin >= td_dom%i_jmax )THEN
-         CALL logger_fatal("DOM INIT: invalid domain. "//&
+      IF( td_dom%i_jmax == 0 )THEN
+         CALL logger_fatal("DOM SIZE NO POLE NO OVERLAP: invalid domain. "//&
          &  "can not get north pole from this coarse grid. "//&
-         &  "check namelist and coarse grid periodicity." )
-      ENDIF
-
-      IF( td_dom%i_imin >= td_dom%i_imax )THEN
-         CALL logger_fatal("DOM INIT: invalid domain. "//&
+         &  "check domain indices and grid periodicity." )
+      ENDIF
+
+      IF( td_dom%i_imin == 0 .OR. td_dom%i_imax == 0 )THEN
+         CALL logger_fatal("DOM SIZE NO POLE NO OVERLAP: invalid domain. "//&
          &  "can not overlap East-West boundary with this coarse grid. "//&
-         &  "check namelist and coarse grid periodicity." )
-      ENDIF
-
-      td_dom%t_dim(1)%i_len = ( td_dom%i_imax ) - & 
-      &                       ( td_dom%i_imin ) + 1 
-
-      td_dom%t_dim(2)%i_len = ( td_dom%i_jmax ) - &
-      &                       ( td_dom%i_jmin ) + 1
+         &  "check domain indices and grid periodicity." )
+      ENDIF
+
+      td_dom%t_dim(1)%i_len = td_dom%i_imax - & 
+      &                       td_dom%i_imin + 1 
+
+      td_dom%t_dim(2)%i_len = td_dom%i_jmax - &
+      &                       td_dom%i_jmin + 1
       
       ! add ghost cell
-      td_dom%i_ighost=1
-      td_dom%i_jghost=1
+      td_dom%i_ghost(:,:)=1
 
       ! periodicity
@@ -930,17 +1076,15 @@
 
    END SUBROUTINE dom__size_no_pole_no_overlap
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine compute size of an extract domain with north fold
+   !> This subroutine compute size of sub domain with north fold
    !> condition, and which overlap east-west boundary
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
    !> @note never tested
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE dom__size_pole_overlap( td_dom )
       IMPLICIT NONE
@@ -954,5 +1098,5 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace("DEFINE POLE OVERLAP: "//&
+      CALL logger_trace("DOM SIZE POLE OVERLAP: "//&
       &  "asian bipole inside domain to extract")
 
@@ -964,9 +1108,10 @@
       IF( il_idom1 > il_imid .OR. il_idom2 > il_imid )THEN
 
-         CALL logger_trace("DEFINE POLE OVERLAP: "//&
+         CALL logger_trace("DOM SIZE POLE OVERLAP: "//&
          &  "canadian bipole inside domain to extract")
-         td_dom%i_imin = td_dom%i_imax
-
-         IF( td_dom%i_jmin == td_dom%i_jmax )THEN
+         td_dom%i_imin = 0
+         td_dom%i_imax = 0
+
+         IF( td_dom%i_jmin == 0 .AND. td_dom%i_jmax == 0 )THEN
             CALL dom__size_global( td_dom )
          ELSE
@@ -980,27 +1125,21 @@
 
          ! east part bigger than west part
-         CALL logger_trace("DEFINE POLE OVERLAP: east part bigger than west part ")
+         CALL logger_trace("DOM SIZE POLE OVERLAP: east part bigger than west part ")
          ! to respect symmetry around asian bipole
          td_dom%i_imax = il_idom1
 
+         IF( td_dom%i_jmin == 0 ) td_dom%i_jmin = 1 
          ! north pole
-         IF( td_dom%i_jmax >= td_dom%t_dim0(2)%i_len-1 )THEN
-            td_dom%i_jmax=MIN( td_dom%i_jmin, & 
-            &                  td_dom%t_dim0(2)%i_len-td_dom%i_jmax )
-         ELSE
-            td_dom%i_jmax=MIN( td_dom%i_jmin, td_dom%i_jmax )
-         ENDIF
-         td_dom%i_jmin=td_dom%i_jmax
+         td_dom%i_jmax = td_dom%t_dim0(2)%i_len
 
          ! compute size
          td_dom%t_dim(1)%i_len = il_idom1  !! no ghost cell ??
          td_dom%t_dim(2)%i_len = ( td_dom%t_dim0(2)%i_len - &
-         &                         ( td_dom%i_jmin ) + 1 ) + &   
+         &                         td_dom%i_jmin + 1 ) + &   
          &                         ( td_dom%t_dim0(2)%i_len - &
-         &                         ( td_dom%i_jmax ) + 1 ) - 2   ! remove north fold condition ?
+         &                         td_dom%i_jmin + 1 ) - 2   ! remove north fold condition ?
 
          ! add ghost cell
-         td_dom%i_ighost=1
-         td_dom%i_jghost=1
+         td_dom%i_ghost(:,:)=1
 
          ! periodicity
